﻿using System;
using System.IO;
using System.Security.Cryptography;
using System.Text;

namespace _3des
{
    internal class TripleDES
    {
        private static SymmetricAlgorithm mCSP = new TripleDESCryptoServiceProvider();
        private static string _key = string.Empty;
        private static string _iv = string.Empty;

        public static string sKey
        {
            get { return _key; }
            set { _key = value; }
        }

        public static string sIV
        {
            get { return _iv; }
            set { _iv = value; }
        }

        /// <summary>
        /// Encrypt
        /// </summary>
        /// <param name="Value"></param>
        /// <returns></returns>
        public static string Encrypt(string Value)
        {
            ICryptoTransform ct;
            MemoryStream ms;
            CryptoStream cs;
            byte[] byt;

            mCSP.Clear();
            mCSP.Key = Convert.FromBase64String(sKey);
            mCSP.IV = Convert.FromBase64String(sIV);
            mCSP.Mode = System.Security.Cryptography.CipherMode.ECB;
            mCSP.Padding = System.Security.Cryptography.PaddingMode.PKCS7;

            ct = mCSP.CreateEncryptor(mCSP.Key, mCSP.IV);
            byt = Encoding.UTF8.GetBytes(Value);
            ms = new MemoryStream();
            cs = new CryptoStream(ms, ct, CryptoStreamMode.Write);
            cs.Write(byt, 0, byt.Length);
            cs.FlushFinalBlock();
            cs.Close();
            
            return Convert.ToBase64String(ms.ToArray());

        }

        /// <summary>
        /// Decrypt
        /// </summary>
        /// <param name="Value"></param>
        /// <returns></returns>
        public static string Decrypt(string Value)
        {
            ICryptoTransform ct;
            MemoryStream ms;
            CryptoStream cs;
            byte[] byt;

            mCSP.Clear();
            mCSP.Key = Convert.FromBase64String(sKey);
            mCSP.IV = Convert.FromBase64String(sIV);
            mCSP.Mode = System.Security.Cryptography.CipherMode.ECB;
            mCSP.Padding = System.Security.Cryptography.PaddingMode.PKCS7;
            
            ct = mCSP.CreateDecryptor(mCSP.Key, mCSP.IV);
            byt = Convert.FromBase64String(Value);
            
            ms = new MemoryStream();
            cs = new CryptoStream(ms, ct, CryptoStreamMode.Write);
            cs.Write(byt, 0, byt.Length);
            cs.FlushFinalBlock();
            cs.Close();
            
            return Encoding.UTF8.GetString(ms.ToArray());

        }

    }

}